package net.pijcke.mazes.generation

import net.pijcke.mazes.grid.Coordinate
import net.pijcke.mazes.grid.Grid

class OpenAll<C: Coordinate<C>, G: Grid<C>>: GenerationAlgorithm<C, G> {

    override fun on(grid: G) {
        for (p in grid.getPositions()) {
            p.neighbours().filter { grid.isWithinBounds(it) }.forEach { grid.link(p, it) }
        }
    }

}
