package net.pijcke.mazes.grid.graph

import net.pijcke.mazes.grid.Grid
import net.pijcke.mazes.grid.Coordinate
import java.util.*

abstract class GraphGrid<C: Coordinate<C>>(private val nodes: Collection<C>): Grid<C> {

    private val edges : MutableSet<Edge<C>> = TreeSet<Edge<C>>()

    override fun getPositions() = nodes

    override fun link(position1: C, position2: C) {
        edges.add(Edge(position2, position1))
        edges.add(Edge(position1, position2))
    }

    override fun linked(position1: C, position2: C): Boolean {
        return edges.contains(Edge(position1, position2))
    }

}
