package net.pijcke.mazes.layout.rectangular

import net.pijcke.mazes.grid.Coordinate

data class CartesianCoordinate(val x: Int, val y: Int) : Coordinate<CartesianCoordinate> {

    override fun neighbours() = listOf(south(), north(), west(), east())

    fun south() = CartesianCoordinate(x, y - 1)
    fun north() = CartesianCoordinate(x, y + 1)
    fun west() = CartesianCoordinate(x - 1, y)
    fun east() = CartesianCoordinate(x + 1, y)

    override fun compareTo(other: CartesianCoordinate): Int {
        return Comparator.comparing(CartesianCoordinate::x)
            .thenComparing(CartesianCoordinate::y)
            .compare(this, other)
    }

}